## binkd 1.1a-96

=== debian/changelog ===
binkd (1.1a-96-1) unstable; urgency=medium

  * New upstream pre-release.
  * Enabled Perl support, this time for real.

 -- Marco d'Itri <md@linux.it>  Sun, 24 Dec 2017 01:45:58 +0100
