## binkd 1.1a-99

=== debian/changelog ===
binkd (1.1a-99-1build1) focal; urgency=medium

  * No-change rebuild for the perl update.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 18 Oct 2019 19:27:01 +0000

binkd (1.1a-99-1) unstable; urgency=medium

  * New upstream pre-release.

 -- Marco d'Itri <md@linux.it>  Sun, 17 Feb 2019 19:37:52 +0100
