=== debian/control ===
--- 
+++ 
@@ -3,9 +3,10 @@
 Priority: optional
 Maintainer: Marco d'Itri <md@linux.it>
 Build-Depends: debhelper (>= 9.20160709), dh-autoreconf, zlib1g-dev, libperl-dev
-Standards-Version: 4.1.2
-Vcs-Git: https://anonscm.debian.org/git/users/md/binkd.git
-Vcs-Browser: https://anonscm.debian.org/cgit/users/md/binkd.git
+Standards-Version: 4.3.0.2
+Rules-Requires-Root: binary-targets
+Vcs-Git: https://salsa.debian.org/md/binkd.git
+Vcs-Browser: https://salsa.debian.org/md/binkd
 
 Package: binkd
 Architecture: any
