## binkd 1.1a-111

=== debian/changelog ===
binkd (1.1a-111-1build1) jammy; urgency=medium

  * No-change rebuild for the perl update.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 06 Feb 2022 13:39:49 +0100

binkd (1.1a-111-1) unstable; urgency=medium

  * New upstream pre-release.

 -- Marco d'Itri <md@linux.it>  Mon, 11 Jan 2021 00:15:13 +0100
