=== debian/control ===
Source: binkd
Section: comm
Priority: optional
Maintainer: Marco d'Itri <md@linux.it>
Build-Depends: debhelper-compat (= 12),
 zlib1g-dev, libperl-dev
Standards-Version: 4.5.0.2
Rules-Requires-Root: binary-targets
Vcs-Git: https://salsa.debian.org/md/binkd.git
Vcs-Browser: https://salsa.debian.org/md/binkd

Package: binkd
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ${perl:Depends}, adduser, lsb-base
Description: FidoTech TCP/IP mailer
 Binkd is a FidoTech mailer designed for use over TCP/IP.
 .
 This program is NOT an internet mail transfer agent.
 If you don't know what it is, you don't need it.
