=== debian/rules ===
#!/usr/bin/make -f

DEB_BUILD_MAINT_OPTIONS=hardening=+pie,+bindnow

D := $(CURDIR)/debian/binkd

%:
	dh $@

override_dh_autoreconf:
	cp mkfls/unix/install-sh mkfls/unix/configure.in mkfls/unix/Makefile.* .
	dh_autoreconf

override_dh_auto_configure:
	dh_auto_configure -- --with-debug --with-https --with-ntlm --with-bwlim --with-perl

override_dh_auto_install:

override_dh_auto_clean:
	[ ! -e Makefile ] || $(MAKE) cleanall

override_dh_installchangelogs:
	dh_installchangelogs HISTORY

override_dh_install:
	cp binkd.cfg binkd.inc $D/etc/binkd/
	install binkd $D/usr/sbin/
	install --mode 755 debian/binkdlogstat $D/usr/sbin/

override_dh_fixperms:
	dh_fixperms
	chown -R 64000:adm $D/var/log/binkd/
	chmod 750 $D/var/log/binkd/
	chown -R 64000:64000 $D/var/spool/ftn/ $D/etc/binkd/binkd.inc
	chmod 600 $D/etc/binkd/binkd.inc
