## binkd 1.1a-115

=== debian/changelog ===
binkd (1.1a-115-1) unstable; urgency=medium

  * New upstream pre-release.
  * Enabled --with-af-force. (Closes: #1011931)
  * Enabled the sandboxing in binkd.service.

 -- Marco d'Itri <md@linux.it>  Sun, 04 Dec 2022 18:58:26 +0100
