=== debian/control ===
--- 
+++ 
@@ -2,9 +2,9 @@
 Section: comm
 Priority: optional
 Maintainer: Marco d'Itri <md@linux.it>
-Build-Depends: debhelper-compat (= 12),
+Build-Depends: debhelper-compat (= 13),
  zlib1g-dev, libperl-dev
-Standards-Version: 4.5.0.2
+Standards-Version: 4.6.1.1
 Rules-Requires-Root: binary-targets
 Vcs-Git: https://salsa.debian.org/md/binkd.git
 Vcs-Browser: https://salsa.debian.org/md/binkd
