=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

D := $(CURDIR)/debian/binkd

%:
	dh $@

execute_before_dh_autoreconf:
	cp mkfls/unix/install-sh mkfls/unix/configure.in mkfls/unix/Makefile.* .

override_dh_auto_configure:
	dh_auto_configure -- \
		--with-af-force \
		--with-bwlim \
		--with-debug \
		--with-https \
		--with-ntlm \
		--with-perl

override_dh_auto_install:

override_dh_auto_clean:
	[ ! -e Makefile ] || $(MAKE) cleanall

override_dh_installchangelogs:
	dh_installchangelogs HISTORY

override_dh_install:
	cp binkd.cfg binkd.inc $D/etc/binkd/
	install binkd $D/usr/sbin/
	install --mode 755 debian/binkdlogstat $D/usr/sbin/

execute_after_dh_fixperms:
	chown -R 64000:adm $D/var/log/binkd/
	chmod 750 $D/var/log/binkd/
	chown -R 64000:64000 $D/var/spool/ftn/ $D/etc/binkd/binkd.inc
	chmod 600 $D/etc/binkd/binkd.inc
