=== debian/watch ===
version=3
opts=filenamemangle=s/.+\/binkd-(\d\S*)\.tar\.gz/@PACKAGE@-$1\.tar\.gz/,uversionmangle=s/_/./g \
  https://github.com/pgul/binkd/tags .*/binkd-(\d\S*)\.tar\.gz
